Class CachePolicy (1.105.0)

public final class CachePolicy extends GeneratedMessage implements CachePolicyOrBuilder

Message containing CachePolicy configuration for URL Map's Route Action.

Protobuf type google.cloud.compute.v1.CachePolicy

Static Fields

CACHE_BYPASS_REQUEST_HEADER_NAMES_FIELD_NUMBER

public static final int CACHE_BYPASS_REQUEST_HEADER_NAMES_FIELD_NUMBER
Field Value
Type Description
int

CACHE_KEY_POLICY_FIELD_NUMBER

public static final int CACHE_KEY_POLICY_FIELD_NUMBER
Field Value
Type Description
int

CACHE_MODE_FIELD_NUMBER

public static final int CACHE_MODE_FIELD_NUMBER
Field Value
Type Description
int

CLIENT_TTL_FIELD_NUMBER

public static final int CLIENT_TTL_FIELD_NUMBER
Field Value
Type Description
int

DEFAULT_TTL_FIELD_NUMBER

public static final int DEFAULT_TTL_FIELD_NUMBER
Field Value
Type Description
int

MAX_TTL_FIELD_NUMBER

public static final int MAX_TTL_FIELD_NUMBER
Field Value
Type Description
int

NEGATIVE_CACHING_FIELD_NUMBER

public static final int NEGATIVE_CACHING_FIELD_NUMBER
Field Value
Type Description
int

NEGATIVE_CACHING_POLICY_FIELD_NUMBER

public static final int NEGATIVE_CACHING_POLICY_FIELD_NUMBER
Field Value
Type Description
int

REQUEST_COALESCING_FIELD_NUMBER

public static final int REQUEST_COALESCING_FIELD_NUMBER
Field Value
Type Description
int

SERVE_WHILE_STALE_FIELD_NUMBER

public static final int SERVE_WHILE_STALE_FIELD_NUMBER
Field Value
Type Description
int

Static Methods

getDefaultInstance()

public static CachePolicy getDefaultInstance()
Returns
Type Description
CachePolicy

getDescriptor()

public static final Descriptors.Descriptor getDescriptor()
Returns
Type Description
Descriptor

newBuilder()

public static CachePolicy.Builder newBuilder()
Returns
Type Description
CachePolicy.Builder

newBuilder(CachePolicy prototype)

public static CachePolicy.Builder newBuilder(CachePolicy prototype)
Parameter
Name Description
prototype CachePolicy
Returns
Type Description
CachePolicy.Builder

parseDelimitedFrom(InputStream input)

public static CachePolicy parseDelimitedFrom(InputStream input)
Parameter
Name Description
input InputStream
Returns
Type Description
CachePolicy
Exceptions
Type Description
IOException

parseDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry)

public static CachePolicy parseDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry)
Parameters
Name Description
input InputStream
extensionRegistry ExtensionRegistryLite
Returns
Type Description
CachePolicy
Exceptions
Type Description
IOException

parseFrom(byte[] data)

public static CachePolicy parseFrom(byte[] data)
Parameter
Name Description
data byte[]
Returns
Type Description
CachePolicy
Exceptions
Type Description
InvalidProtocolBufferException

parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry)

public static CachePolicy parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry)
Parameters
Name Description
data byte[]
extensionRegistry ExtensionRegistryLite
Returns
Type Description
CachePolicy
Exceptions
Type Description
InvalidProtocolBufferException

parseFrom(ByteString data)

public static CachePolicy parseFrom(ByteString data)
Parameter
Name Description
data ByteString
Returns
Type Description
CachePolicy
Exceptions
Type Description
InvalidProtocolBufferException

parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry)

public static CachePolicy parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry)
Parameters
Name Description
data ByteString
extensionRegistry ExtensionRegistryLite
Returns
Type Description
CachePolicy
Exceptions
Type Description
InvalidProtocolBufferException

parseFrom(CodedInputStream input)

public static CachePolicy parseFrom(CodedInputStream input)
Parameter
Name Description
input CodedInputStream
Returns
Type Description
CachePolicy
Exceptions
Type Description
IOException

parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)

public static CachePolicy parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)
Parameters
Name Description
input CodedInputStream
extensionRegistry ExtensionRegistryLite
Returns
Type Description
CachePolicy
Exceptions
Type Description
IOException

parseFrom(InputStream input)

public static CachePolicy parseFrom(InputStream input)
Parameter
Name Description
input InputStream
Returns
Type Description
CachePolicy
Exceptions
Type Description
IOException

parseFrom(InputStream input, ExtensionRegistryLite extensionRegistry)

public static CachePolicy parseFrom(InputStream input, ExtensionRegistryLite extensionRegistry)
Parameters
Name Description
input InputStream
extensionRegistry ExtensionRegistryLite
Returns
Type Description
CachePolicy
Exceptions
Type Description
IOException

parseFrom(ByteBuffer data)

public static CachePolicy parseFrom(ByteBuffer data)
Parameter
Name Description
data ByteBuffer
Returns
Type Description
CachePolicy
Exceptions
Type Description
InvalidProtocolBufferException

parseFrom(ByteBuffer data, ExtensionRegistryLite extensionRegistry)

public static CachePolicy parseFrom(ByteBuffer data, ExtensionRegistryLite extensionRegistry)
Parameters
Name Description
data ByteBuffer
extensionRegistry ExtensionRegistryLite
Returns
Type Description
CachePolicy
Exceptions
Type Description
InvalidProtocolBufferException

parser()

public static Parser<CachePolicy> parser()
Returns
Type Description
Parser<CachePolicy>

Methods

equals(Object obj)

public boolean equals(Object obj)
Parameter
Name Description
obj Object
Returns
Type Description
boolean
Overrides

getCacheBypassRequestHeaderNames(int index)

public String getCacheBypassRequestHeaderNames(int index)

Bypass the cache when the specified request headers are matched by name, e.g. Pragma or Authorization headers. Values are case-insensitive. Up to 5 header names can be specified. The cache is bypassed for all cacheMode values.

repeated string cache_bypass_request_header_names = 197581440;

Parameter
Name Description
index int

The index of the element to return.

Returns
Type Description
String

The cacheBypassRequestHeaderNames at the given index.

getCacheBypassRequestHeaderNamesBytes(int index)

public ByteString getCacheBypassRequestHeaderNamesBytes(int index)

Bypass the cache when the specified request headers are matched by name, e.g. Pragma or Authorization headers. Values are case-insensitive. Up to 5 header names can be specified. The cache is bypassed for all cacheMode values.

repeated string cache_bypass_request_header_names = 197581440;

Parameter
Name Description
index int

The index of the value to return.

Returns
Type Description
ByteString

The bytes of the cacheBypassRequestHeaderNames at the given index.

getCacheBypassRequestHeaderNamesCount()

public int getCacheBypassRequestHeaderNamesCount()

Bypass the cache when the specified request headers are matched by name, e.g. Pragma or Authorization headers. Values are case-insensitive. Up to 5 header names can be specified. The cache is bypassed for all cacheMode values.

repeated string cache_bypass_request_header_names = 197581440;

Returns
Type Description
int

The count of cacheBypassRequestHeaderNames.

getCacheBypassRequestHeaderNamesList()

public ProtocolStringList getCacheBypassRequestHeaderNamesList()

Bypass the cache when the specified request headers are matched by name, e.g. Pragma or Authorization headers. Values are case-insensitive. Up to 5 header names can be specified. The cache is bypassed for all cacheMode values.

repeated string cache_bypass_request_header_names = 197581440;

Returns
Type Description
ProtocolStringList

A list containing the cacheBypassRequestHeaderNames.

getCacheKeyPolicy()

public CachePolicyCacheKeyPolicy getCacheKeyPolicy()

The cache key configuration. If not specified, the default behavior depends on the backend type: for Backend Services, the complete request URI is used; for Backend Buckets, the request URI is used without the protocol or host, and only query parameters known to Cloud Storage are included.

optional .google.cloud.compute.v1.CachePolicyCacheKeyPolicy cache_key_policy = 159263727;

Returns
Type Description
CachePolicyCacheKeyPolicy

The cacheKeyPolicy.

getCacheKeyPolicyOrBuilder()

public CachePolicyCacheKeyPolicyOrBuilder getCacheKeyPolicyOrBuilder()

The cache key configuration. If not specified, the default behavior depends on the backend type: for Backend Services, the complete request URI is used; for Backend Buckets, the request URI is used without the protocol or host, and only query parameters known to Cloud Storage are included.

optional .google.cloud.compute.v1.CachePolicyCacheKeyPolicy cache_key_policy = 159263727;

Returns
Type Description
CachePolicyCacheKeyPolicyOrBuilder

getCacheMode()

public String getCacheMode()

Specifies the cache setting for all responses from this route. If not specified, Cloud CDN uses CACHE_ALL_STATIC mode. Check the CacheMode enum for the list of possible values.

optional string cache_mode = 28877888;

Returns
Type Description
String

The cacheMode.

getCacheModeBytes()

public ByteString getCacheModeBytes()

Specifies the cache setting for all responses from this route. If not specified, Cloud CDN uses CACHE_ALL_STATIC mode. Check the CacheMode enum for the list of possible values.

optional string cache_mode = 28877888;

Returns
Type Description
ByteString

The bytes for cacheMode.

getClientTtl()

public Duration getClientTtl()

Specifies a separate client (e.g. browser client) maximum TTL for cached content. This is used to clamp the max-age (or Expires) value sent to the client. With FORCE_CACHE_ALL, the lesser of clientTtl and defaultTtl is used for the response max-age directive, along with a "public" directive. For cacheable content in CACHE_ALL_STATIC mode, clientTtl clamps the max-age from the origin (if specified), or else sets the response max-age directive to the lesser of the clientTtl and defaultTtl, and also ensures a "public" cache-control directive is present. The maximum allowed value is 31,622,400s (1 year). If not specified, Cloud CDN uses 3600s (1 hour) for CACHE_ALL_STATIC mode. Cannot exceed maxTtl. Cannot be specified when cacheMode is USE_ORIGIN_HEADERS.

optional .google.cloud.compute.v1.Duration client_ttl = 29034360;

Returns
Type Description
Duration

The clientTtl.

getClientTtlOrBuilder()

public DurationOrBuilder getClientTtlOrBuilder()

Specifies a separate client (e.g. browser client) maximum TTL for cached content. This is used to clamp the max-age (or Expires) value sent to the client. With FORCE_CACHE_ALL, the lesser of clientTtl and defaultTtl is used for the response max-age directive, along with a "public" directive. For cacheable content in CACHE_ALL_STATIC mode, clientTtl clamps the max-age from the origin (if specified), or else sets the response max-age directive to the lesser of the clientTtl and defaultTtl, and also ensures a "public" cache-control directive is present. The maximum allowed value is 31,622,400s (1 year). If not specified, Cloud CDN uses 3600s (1 hour) for CACHE_ALL_STATIC mode. Cannot exceed maxTtl. Cannot be specified when cacheMode is USE_ORIGIN_HEADERS.

optional .google.cloud.compute.v1.Duration client_ttl = 29034360;

Returns
Type Description
DurationOrBuilder

getDefaultInstanceForType()

public CachePolicy getDefaultInstanceForType()
Returns
Type Description
CachePolicy

getDefaultTtl()

public Duration getDefaultTtl()

Specifies the default TTL for cached content for responses that do not have an existing valid TTL (max-age or s-maxage). Setting a TTL of "0" means "always revalidate". The value of defaultTtl cannot be set to a value greater than that of maxTtl. When the cacheMode is set to FORCE_CACHE_ALL, the defaultTtl will overwrite the TTL set in all responses. The maximum allowed value is 31,622,400s (1 year). Infrequently accessed objects may be evicted from the cache before the defined TTL. If not specified, Cloud CDN uses 3600s (1 hour) for CACHE_ALL_STATIC and FORCE_CACHE_ALL modes. Cannot be specified when cacheMode is USE_ORIGIN_HEADERS.

optional .google.cloud.compute.v1.Duration default_ttl = 100253422;

Returns
Type Description
Duration

The defaultTtl.

getDefaultTtlOrBuilder()

public DurationOrBuilder getDefaultTtlOrBuilder()

Specifies the default TTL for cached content for responses that do not have an existing valid TTL (max-age or s-maxage). Setting a TTL of "0" means "always revalidate". The value of defaultTtl cannot be set to a value greater than that of maxTtl. When the cacheMode is set to FORCE_CACHE_ALL, the defaultTtl will overwrite the TTL set in all responses. The maximum allowed value is 31,622,400s (1 year). Infrequently accessed objects may be evicted from the cache before the defined TTL. If not specified, Cloud CDN uses 3600s (1 hour) for CACHE_ALL_STATIC and FORCE_CACHE_ALL modes. Cannot be specified when cacheMode is USE_ORIGIN_HEADERS.

optional .google.cloud.compute.v1.Duration default_ttl = 100253422;

Returns
Type Description
DurationOrBuilder

getMaxTtl()

public Duration getMaxTtl()

Specifies the maximum allowed TTL for cached content. Cache directives that attempt to set a max-age or s-maxage higher than this, or an Expires header more than maxTtl seconds in the future will be capped at the value of maxTtl, as if it were the value of an s-maxage Cache-Control directive. Headers sent to the client will not be modified. Setting a TTL of "0" means "always revalidate". The maximum allowed value is 31,622,400s (1 year). Infrequently accessed objects may be evicted from the cache before the defined TTL. If not specified, Cloud CDN uses 86400s (1 day) for CACHE_ALL_STATIC mode. Can be specified only for CACHE_ALL_STATIC cache mode.

optional .google.cloud.compute.v1.Duration max_ttl = 307578001;

Returns
Type Description
Duration

The maxTtl.

getMaxTtlOrBuilder()

public DurationOrBuilder getMaxTtlOrBuilder()

Specifies the maximum allowed TTL for cached content. Cache directives that attempt to set a max-age or s-maxage higher than this, or an Expires header more than maxTtl seconds in the future will be capped at the value of maxTtl, as if it were the value of an s-maxage Cache-Control directive. Headers sent to the client will not be modified. Setting a TTL of "0" means "always revalidate". The maximum allowed value is 31,622,400s (1 year). Infrequently accessed objects may be evicted from the cache before the defined TTL. If not specified, Cloud CDN uses 86400s (1 day) for CACHE_ALL_STATIC mode. Can be specified only for CACHE_ALL_STATIC cache mode.

optional .google.cloud.compute.v1.Duration max_ttl = 307578001;

Returns
Type Description
DurationOrBuilder

getNegativeCaching()

public boolean getNegativeCaching()

Negative caching allows per-status code TTLs to be set, in order to apply fine-grained caching for common errors or redirects. This can reduce the load on your origin and improve end-user experience by reducing response latency. When the cacheMode is set to CACHE_ALL_STATIC or USE_ORIGIN_HEADERS, negative caching applies to responses with the specified response code that lack any Cache-Control, Expires, or Pragma: no-cache directives. When the cacheMode is set to FORCE_CACHE_ALL, negative caching applies to all responses with the specified response code, and overrides any caching headers. By default, Cloud CDN applies the following TTLs to these HTTP status codes:

  • 300 (Multiple Choice), 301, 308 (Permanent Redirects): 10m
  • 404 (Not Found), 410 (Gone), 451 (Unavailable For Legal Reasons): 120s
  • 405 (Method Not Found), 501 (Not Implemented): 60s

    These defaults can be overridden in negativeCachingPolicy. If not specified, Cloud CDN applies negative caching by default.

optional bool negative_caching = 336110005;

Returns
Type Description
boolean

The negativeCaching.

getNegativeCachingPolicy(int index)

public CachePolicyNegativeCachingPolicy getNegativeCachingPolicy(int index)

Sets a cache TTL for the specified HTTP status code. negativeCaching must be enabled to configure negativeCachingPolicy. Omitting the policy and leaving negativeCaching enabled will use Cloud CDN's default cache TTLs. Note that when specifying an explicit negativeCachingPolicy, you should take care to specify a cache TTL for all response codes that you wish to cache. Cloud CDN will not apply any default negative caching when a policy exists.

repeated .google.cloud.compute.v1.CachePolicyNegativeCachingPolicy negative_caching_policy = 155359996;

Parameter
Name Description
index int
Returns
Type Description
CachePolicyNegativeCachingPolicy

getNegativeCachingPolicyCount()

public int getNegativeCachingPolicyCount()

Sets a cache TTL for the specified HTTP status code. negativeCaching must be enabled to configure negativeCachingPolicy. Omitting the policy and leaving negativeCaching enabled will use Cloud CDN's default cache TTLs. Note that when specifying an explicit negativeCachingPolicy, you should take care to specify a cache TTL for all response codes that you wish to cache. Cloud CDN will not apply any default negative caching when a policy exists.

repeated .google.cloud.compute.v1.CachePolicyNegativeCachingPolicy negative_caching_policy = 155359996;

Returns
Type Description
int

getNegativeCachingPolicyList()

public List<CachePolicyNegativeCachingPolicy> getNegativeCachingPolicyList()

Sets a cache TTL for the specified HTTP status code. negativeCaching must be enabled to configure negativeCachingPolicy. Omitting the policy and leaving negativeCaching enabled will use Cloud CDN's default cache TTLs. Note that when specifying an explicit negativeCachingPolicy, you should take care to specify a cache TTL for all response codes that you wish to cache. Cloud CDN will not apply any default negative caching when a policy exists.

repeated .google.cloud.compute.v1.CachePolicyNegativeCachingPolicy negative_caching_policy = 155359996;

Returns
Type Description
List<CachePolicyNegativeCachingPolicy>

getNegativeCachingPolicyOrBuilder(int index)

public CachePolicyNegativeCachingPolicyOrBuilder getNegativeCachingPolicyOrBuilder(int index)

Sets a cache TTL for the specified HTTP status code. negativeCaching must be enabled to configure negativeCachingPolicy. Omitting the policy and leaving negativeCaching enabled will use Cloud CDN's default cache TTLs. Note that when specifying an explicit negativeCachingPolicy, you should take care to specify a cache TTL for all response codes that you wish to cache. Cloud CDN will not apply any default negative caching when a policy exists.

repeated .google.cloud.compute.v1.CachePolicyNegativeCachingPolicy negative_caching_policy = 155359996;

Parameter
Name Description
index int
Returns
Type Description
CachePolicyNegativeCachingPolicyOrBuilder

getNegativeCachingPolicyOrBuilderList()

public List<? extends CachePolicyNegativeCachingPolicyOrBuilder> getNegativeCachingPolicyOrBuilderList()

Sets a cache TTL for the specified HTTP status code. negativeCaching must be enabled to configure negativeCachingPolicy. Omitting the policy and leaving negativeCaching enabled will use Cloud CDN's default cache TTLs. Note that when specifying an explicit negativeCachingPolicy, you should take care to specify a cache TTL for all response codes that you wish to cache. Cloud CDN will not apply any default negative caching when a policy exists.

repeated .google.cloud.compute.v1.CachePolicyNegativeCachingPolicy negative_caching_policy = 155359996;

Returns
Type Description
List<? extends com.google.cloud.compute.v1.CachePolicyNegativeCachingPolicyOrBuilder>

getParserForType()

public Parser<CachePolicy> getParserForType()
Returns
Type Description
Parser<CachePolicy>
Overrides

getRequestCoalescing()

public boolean getRequestCoalescing()

If true then Cloud CDN will combine multiple concurrent cache fill requests into a small number of requests to the origin. If not specified, Cloud CDN applies request coalescing by default.

optional bool request_coalescing = 532808276;

Returns
Type Description
boolean

The requestCoalescing.

getSerializedSize()

public int getSerializedSize()
Returns
Type Description
int
Overrides

getServeWhileStale()

public Duration getServeWhileStale()

Serve existing content from the cache (if available) when revalidating content with the origin, or when an error is encountered when refreshing the cache. This setting defines the default "max-stale" duration for any cached responses that do not specify a max-stale directive. Stale responses that exceed the TTL configured here will not be served. The default limit (max-stale) is 86400s (1 day), which will allow stale content to be served up to this limit beyond the max-age (or s-maxage) of a cached response. The maximum allowed value is 604800 (1 week). Set this to zero (0) to disable serve-while-stale.

optional .google.cloud.compute.v1.Duration serve_while_stale = 236682203;

Returns
Type Description
Duration

The serveWhileStale.

getServeWhileStaleOrBuilder()

public DurationOrBuilder getServeWhileStaleOrBuilder()

Serve existing content from the cache (if available) when revalidating content with the origin, or when an error is encountered when refreshing the cache. This setting defines the default "max-stale" duration for any cached responses that do not specify a max-stale directive. Stale responses that exceed the TTL configured here will not be served. The default limit (max-stale) is 86400s (1 day), which will allow stale content to be served up to this limit beyond the max-age (or s-maxage) of a cached response. The maximum allowed value is 604800 (1 week). Set this to zero (0) to disable serve-while-stale.

optional .google.cloud.compute.v1.Duration serve_while_stale = 236682203;

Returns
Type Description
DurationOrBuilder

hasCacheKeyPolicy()

public boolean hasCacheKeyPolicy()

The cache key configuration. If not specified, the default behavior depends on the backend type: for Backend Services, the complete request URI is used; for Backend Buckets, the request URI is used without the protocol or host, and only query parameters known to Cloud Storage are included.

optional .google.cloud.compute.v1.CachePolicyCacheKeyPolicy cache_key_policy = 159263727;

Returns
Type Description
boolean

Whether the cacheKeyPolicy field is set.

hasCacheMode()

public boolean hasCacheMode()

Specifies the cache setting for all responses from this route. If not specified, Cloud CDN uses CACHE_ALL_STATIC mode. Check the CacheMode enum for the list of possible values.

optional string cache_mode = 28877888;

Returns
Type Description
boolean

Whether the cacheMode field is set.

hasClientTtl()

public boolean hasClientTtl()

Specifies a separate client (e.g. browser client) maximum TTL for cached content. This is used to clamp the max-age (or Expires) value sent to the client. With FORCE_CACHE_ALL, the lesser of clientTtl and defaultTtl is used for the response max-age directive, along with a "public" directive. For cacheable content in CACHE_ALL_STATIC mode, clientTtl clamps the max-age from the origin (if specified), or else sets the response max-age directive to the lesser of the clientTtl and defaultTtl, and also ensures a "public" cache-control directive is present. The maximum allowed value is 31,622,400s (1 year). If not specified, Cloud CDN uses 3600s (1 hour) for CACHE_ALL_STATIC mode. Cannot exceed maxTtl. Cannot be specified when cacheMode is USE_ORIGIN_HEADERS.

optional .google.cloud.compute.v1.Duration client_ttl = 29034360;

Returns
Type Description
boolean

Whether the clientTtl field is set.

hasDefaultTtl()

public boolean hasDefaultTtl()

Specifies the default TTL for cached content for responses that do not have an existing valid TTL (max-age or s-maxage). Setting a TTL of "0" means "always revalidate". The value of defaultTtl cannot be set to a value greater than that of maxTtl. When the cacheMode is set to FORCE_CACHE_ALL, the defaultTtl will overwrite the TTL set in all responses. The maximum allowed value is 31,622,400s (1 year). Infrequently accessed objects may be evicted from the cache before the defined TTL. If not specified, Cloud CDN uses 3600s (1 hour) for CACHE_ALL_STATIC and FORCE_CACHE_ALL modes. Cannot be specified when cacheMode is USE_ORIGIN_HEADERS.

optional .google.cloud.compute.v1.Duration default_ttl = 100253422;

Returns
Type Description
boolean

Whether the defaultTtl field is set.

hasMaxTtl()

public boolean hasMaxTtl()

Specifies the maximum allowed TTL for cached content. Cache directives that attempt to set a max-age or s-maxage higher than this, or an Expires header more than maxTtl seconds in the future will be capped at the value of maxTtl, as if it were the value of an s-maxage Cache-Control directive. Headers sent to the client will not be modified. Setting a TTL of "0" means "always revalidate". The maximum allowed value is 31,622,400s (1 year). Infrequently accessed objects may be evicted from the cache before the defined TTL. If not specified, Cloud CDN uses 86400s (1 day) for CACHE_ALL_STATIC mode. Can be specified only for CACHE_ALL_STATIC cache mode.

optional .google.cloud.compute.v1.Duration max_ttl = 307578001;

Returns
Type Description
boolean

Whether the maxTtl field is set.

hasNegativeCaching()

public boolean hasNegativeCaching()

Negative caching allows per-status code TTLs to be set, in order to apply fine-grained caching for common errors or redirects. This can reduce the load on your origin and improve end-user experience by reducing response latency. When the cacheMode is set to CACHE_ALL_STATIC or USE_ORIGIN_HEADERS, negative caching applies to responses with the specified response code that lack any Cache-Control, Expires, or Pragma: no-cache directives. When the cacheMode is set to FORCE_CACHE_ALL, negative caching applies to all responses with the specified response code, and overrides any caching headers. By default, Cloud CDN applies the following TTLs to these HTTP status codes:

  • 300 (Multiple Choice), 301, 308 (Permanent Redirects): 10m
  • 404 (Not Found), 410 (Gone), 451 (Unavailable For Legal Reasons): 120s
  • 405 (Method Not Found), 501 (Not Implemented): 60s

    These defaults can be overridden in negativeCachingPolicy. If not specified, Cloud CDN applies negative caching by default.

optional bool negative_caching = 336110005;

Returns
Type Description
boolean

Whether the negativeCaching field is set.

hasRequestCoalescing()

public boolean hasRequestCoalescing()

If true then Cloud CDN will combine multiple concurrent cache fill requests into a small number of requests to the origin. If not specified, Cloud CDN applies request coalescing by default.

optional bool request_coalescing = 532808276;

Returns
Type Description
boolean

Whether the requestCoalescing field is set.

hasServeWhileStale()

public boolean hasServeWhileStale()

Serve existing content from the cache (if available) when revalidating content with the origin, or when an error is encountered when refreshing the cache. This setting defines the default "max-stale" duration for any cached responses that do not specify a max-stale directive. Stale responses that exceed the TTL configured here will not be served. The default limit (max-stale) is 86400s (1 day), which will allow stale content to be served up to this limit beyond the max-age (or s-maxage) of a cached response. The maximum allowed value is 604800 (1 week). Set this to zero (0) to disable serve-while-stale.

optional .google.cloud.compute.v1.Duration serve_while_stale = 236682203;

Returns
Type Description
boolean

Whether the serveWhileStale field is set.

hashCode()

public int hashCode()
Returns
Type Description
int
Overrides

internalGetFieldAccessorTable()

protected GeneratedMessage.FieldAccessorTable internalGetFieldAccessorTable()
Returns
Type Description
FieldAccessorTable
Overrides

isInitialized()

public final boolean isInitialized()
Returns
Type Description
boolean
Overrides

newBuilderForType()

public CachePolicy.Builder newBuilderForType()
Returns
Type Description
CachePolicy.Builder

newBuilderForType(AbstractMessage.BuilderParent parent)

protected CachePolicy.Builder newBuilderForType(AbstractMessage.BuilderParent parent)
Parameter
Name Description
parent BuilderParent
Returns
Type Description
CachePolicy.Builder
Overrides

toBuilder()

public CachePolicy.Builder toBuilder()
Returns
Type Description
CachePolicy.Builder

writeTo(CodedOutputStream output)

public void writeTo(CodedOutputStream output)
Parameter
Name Description
output CodedOutputStream
Overrides
Exceptions
Type Description
IOException